; by masa
; GCD(HL, DE) -> HL
        org  0000h
        ld   hl, 78
        ld   de, 104
;
        or   a          ; cp HL, DE
        sbc  hl, de
        add  hl, de  
        jr   z, done
        jr   nc, wo     ; hl > de

        push hl         ; swap hl,de
        push de
        pop  hl
        pop  de

wo:     xor  a          ; ld a,0
        cp   e
        jr   nz, l0
        cp   d
        jr   z, done 
l0:     ld   b, 1

w0:     bit  0, e       ; while (DE & 1 && HL & 1 == 0) { /* DE, HL - even */
        jr   nz, e0     ;
        bit  0, l
        jr   nz, e0
        sra  d
        rr   e          ; DE >>= 1
        sra  h
        rr   l          ; HL >>= 1
        inc  b          ; b++
        jr   w0

e0:     push bc         ; push b
        bit  0, l       ; BC = (HL & 1) ? -DE : HL
        jr   z, l1
        push de
        pop  bc
        xor  a          ;   BC = neg DE
        sub  c
        ld   c,a
        sbc  a,a
        sub  b
        ld   b,a
        jr   w1

l1:     push hl
        pop  bc         ;   BC = HL

;
w1:     xor  a          ; while (BC) {
        cp   c
        jr   nz, w2
        cp   b
        jr   z, exit

w2:     bit  0, c       ;   while (BC & 1 == 0)
        jr   nz, e2
        sra  b
        rr   c          ;     BC >>= 1
        jr   w2

e2:     push bc         ;   if (BC > 0)
        bit  7, b
        jr   nz, l2
        pop  hl         ;     HL = BC
        jr   l3

l2:     pop  de         ;   else
        xor  a          ;     DE = neg BC
        sub  e
        ld   e,a
        sbc  a,a
        sub  d
        ld   d,a

l3:     push hl         ;   BC = HL-DE
        sbc  hl, de
        push hl
        pop  bc
        pop  hl
        jr   w1         ; }

exit:   pop  bc         ; HL <<= B-1;
        jr   l4
d0:     sla  l          ;     HL <<= 1
        rl   h          
l4:     djnz d0         ;            // Bレジスタから1を引き、その結果が0でなければジャンプ

done:   halt            ; hl が gcd

